/*
 * Solution5_Low_Power.c
 *
 * 쐬: 2016N26 10:15:32
 * : rupali.honrao
 */ 
#define F_CPU 16000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/sleep.h>
#include <avr/power.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>

uint16_t adc_res=0;

void InitADC()
{
	// Vref=AVccI
	ADMUX |= (1<<REFS0);
	// Ou128ɐݒ肵ADC
	ADCSRA |= (1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADEN);
}

uint16_t ReadADC(uint8_t ADCchannel)
{
	// SՕƋADCقI
	ADMUX = (ADMUX & 0xF0) | (ADCchannel & 0x0F);
	// Pƕϊ
	ADCSRA |= (1<<ADSC);
	// A/Dϊ҂
	while( ADCSRA & (1<<ADSC) );
	return ADC;
}

void optimize_power_consumption()
{
	/* ADC݂޼ٓ͊ɏՕ֎~ */
	DIDR0 = (1 << ADC5D) | (1 << ADC4D) | (1 << ADC3D) | (1 << ADC2D) | (1 << ADC1D) | (1 << ADC0D);
	DIDR0 |= 0xC0;	/* ADC7DADC6Dͯ ̧قŖ`Âɂ̕@ޯĂݒ */

	/* ۸ޔr݂޼ٓ͊ɏՕ֎~ */
	DIDR1 |= (1 << AIN1D) | (1 << AIN0D);
	/* ۸ޔr֎~ */
	ACSR |= (1 << ACD);

	/* gpӋ@\ւ̓d͒~ */
	PRR0 = 0xFE;
	PRR1 = 0x3F;
	/* gp݂ٱߓ͂ƂĐݒ */
	DDRB &= 0xE0;
	DDRC &= 0xC9;
	DDRD &= 0x03;
	DDRE &=0xF3;

	PORTB |=~(0xE0);
	PORTC |=~(0xC9);
	PORTD |=~(0x03);
	PORTE |=~(0xf3);

	/* ޯ ςOFF */

	/* 荞݋֎~ */
	cli();
	/* ޯ  ؾ */
	wdt_reset();
	/* MCUSRWDRF(0) */
	MCUSR &= ~(1<<WDRF);
	/* WDTOFF */
 	WDTCSR = 0x00;
	/* x~ݒ */
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);
}

ISR (PCINT0_vect)
{
	if (!(PINB & (1<<PINB7)))	// PINB7Low(؂ւ퉟)ȂA
	{
		PORTB |= (1<<PORTB5);	// LEDON
	}
	else
	{
		PORTB &= ~(1<<PORTB5);	// LEDOFF
	}
}

int main(void)
{
	DDRB &= ~(1<<DDB7);			// PORTB7͂ƂĐݒ
	DDRC &= ~(1<<DDC0);			// PORTC0͂ƂĐݒ
	DDRB |=  (1<<DDB5);			// PORTB5o͂ƂĐݒ

	InitADC();
	optimize_power_consumption();

	PCMSK0 |= (1<<PCINT7);		// ݕϊ荞7
	PCICR |= (1<<PCIE0);		// PCINTp荞݋ޯĂ
	sei();

	while (1)
	{
		ADCSRA &= ~(1 << ADEN);
		power_adc_disable();
		sleep_mode();
		power_adc_enable();
		ADCSRA |= (1 << ADEN);

//		_delay_ms(500);
//		PINB |= 1<<PINB5;		// LED ON/OFFݐ؂ւ
		adc_res=ReadADC(0)	;
	}
}
